#!/usr/bin/perl

# 0 - motifs - gos file - training set
# 1 - output profile?
# 2 - output predictors for each motif
# 3 - motif id file
# 4 - output - frequency

$noGos = 0;
%go2id = ();
%id2go = ();

%goCounts = ();
%motifCounts = ();
%mgCounts = ();

$noProteins = 0;

# first read all motifs

# open motif file

%motif2id = ();
%id2motif = ();

open (FH, $ARGV [3]);

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 @words = split (" ", $aLine);
 $id = $words [0];
 $motif = $words [1];

 $motif2id {$motif} = $id;
 $id2motif {$id} = $motif;

}

close (FH);

# done with that

open (FH, $ARGV [0]);

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 if ($aLine =~ /^([^-]*)-([^-]*)$/) {

  $motifs = $1;
  $gos = $2;

  @mWords = split (" ", $motifs);
  @gWords = split (" ", $gos);

  $Nh = @mWords;

  if ($Nh < 30000) {

  foreach $aGo (@gWords) {

   if (! exists ($go2id {$aGo})) {

    $go2id {$aGo} = $noGos;
    $id2go {$noGos} = $aGo;
    $noGos++;

   }

   # each of these have occurred in yet one more protein

   if (exists ($goCounts {$go2id {$aGo}})) {

    $goCounts {$go2id {$aGo}} = $goCounts {$go2id {$aGo}} + 1;

   }

   else {

    $goCounts {$go2id {$aGo}} = 1;

   }

  }

  # and these should be handled
  # we assume no term is assigned twice to an example!

  foreach $aMotif (@mWords) {

   # this motif occurs

   if (exists ($motifCounts {$aMotif})) {

    $motifCounts {$aMotif} = $motifCounts {$aMotif} + 1;

   }

   else {

    $motifCounts {$aMotif} = 1;

   }

   # with the gos
 
   %lGos = ();

   if (exists ($mgCounts {$aMotif})) {

    foreach $aGo (split (" ", $mgCounts {$aMotif})) {

     if ($aGo =~ /^(\d*)-(\d*)$/) {

      $goId = $1;
      $goCount = $2;
      $lGos {$goId} = $goCount;

     }

     else {

      print "Parse error $aGo\n";

     }

    }

   }

   foreach $aGo (@gWords) {

    # assignment of term to motif

    if (exists ($lGos {$go2id {$aGo}})) {

     $lGos {$go2id {$aGo}} = $lGos {$go2id {$aGo}} + 1;

    }

    else {

     $lGos {$go2id {$aGo}} = 1;

    }

   }

   $ksS = "";

   foreach $aGo (keys % lGos) {

    $ksS = $ksS.$aGo."-".$lGos {$aGo}." ";

   }

   chomp ($ksS);

   $mgCounts {$aMotif} = $ksS;

  }

  }

  else {

   print "$Nh is too high.\n";

  }

 }

 if ($noProteins % 1000 == 0) {

  print "$noProteins read.\n";

 }

 $noProteins++;

}

close (FH);

%profiles = ();

open (FH, ">$ARGV[1]");

# thus, all counts have been done...
# and what do we do then?
# check for signal
# we are interested in motifs predicting terms

# we will store domain motif go ratios

%singleRatios = ();
%singleGos = ();

foreach $aMotif (keys % motifCounts) {

 # here: consider only singles

 if (length ($id2motif {$aMotif}) == 7) {

  $noOfMotif = $motifCounts {$aMotif}; # it occurs this many times

  foreach $aGo (split (" ", $mgCounts {$aMotif})) {

   $aGo =~ /^(\d*)-(\d*)$/;
   $goId = $1;
   $goCount = $2;

   # so, is there anything here?

   $inRatio = $goCount / $noOfMotif; # this is the ratio of the motif that has term goId

   $singleRatios {$aMotif."-".$goId} = $inRatio;
   $singleGos {$aMotif."-".$goId} = $goCount;

  }

 }

}

$nM = 0;

open (FH2, ">$ARGV[4]"); # frequency file output

foreach $aMotif (keys % motifCounts) {

 # these are exactly all motifs that have been observed
 # check their contents

 $noOfMotif = $motifCounts {$aMotif};

 @preds = ();

 foreach $aGo (split (" ", $mgCounts {$aMotif})) {

  $aGo =~ /^(\d*)-(\d*)$/;
  $goId = $1;
  $goCount = $2;

  # so, is there anything here?

  $inRatio = ($goCount + 1) / ($goCounts {$goId} + 1); 

  # this is the fraction of proteins containing this motif
  # that have the term - should be 1 for necessities
  # this ratio is relevant in comparison to the ratio
  # of the motif count versus the total number of proteins
  # that is, prior distribution of the term

  # technically, we could check significant enrichment
  # for terms, and then simply use the set of significant predictor 
  # motifs that emerge...

  $inMotifRatio = $goCount / $noOfMotif; # ratio of motifed sequences that
                                         # have the class

  $priorRatio = $goCounts {$goId} / $noProteins; # ratio of proteins that have the class

  # we thus know that if this ratio is significantly
  # higher, we have something...

  # frequency check

  if (length ($id2motif {$aMotif}) > 7) {

   # heteromulti-domain architecture

   $ratioCount = 0;
   $ratioSum = 0;

   $sS = "";

   foreach $aDomain (split (/\*/, $id2motif {$aMotif})) {

    $ratioSum = $ratioSum + $singleRatios {$motif2id {$aDomain}."-".$goId};
    $ratioCount++;

    $bS = $singleGos {$motif2id {$aDomain}."-".$goId};

    $sS = $sS.$aDomain.":".$bS."/".$motifCounts {$motif2id {$aDomain}}." ";

   }

   $meanComponentRatio = $ratioSum / $ratioCount;

   # so?

   $finalRatio = $inMotifRatio / $meanComponentRatio;

   print FH2 "$finalRatio $id2go{$goId} $id2motif{$aMotif}:$goCount"."/"."$noOfMotif $sS\n";

  }

  # suppose we compute this, and verify it
  # we then add the term to significant predictions of this motif

  if ($inMotifRatio > $priorRatio) {

   $randomP = hypergeom ($goCounts {$goId}, ($noProteins - $goCounts {$goId}), $noOfMotif, $goCount);

   if ($randomP < 0.001) {

    push (@preds, $id2go {$goId});

   } 

  }

  # we wish to duplicate the old implementation in building a profile
  # it states, that for a motif - keep track on its in to out ratio

  $outRatio = ($noOfMotif - $goCount + 1) / ($noProteins - $goCounts {$goId} + 1);

  if ($outRatio == 0) {

#   $outRatio = 0.0000001;

  }

  $repRatio = log ($inRatio) - log ($outRatio);

  if (exists ($profiles {$goId})) {

   $profiles {$goId} = $profiles {$goId}." ".$aMotif."=".$repRatio;

  }

  else {

   $profiles {$goId} = $aMotif."=".$repRatio;

  }

 }

 $Np = @preds;

 if ($Np > 0) {

  $sS = "";
  
  foreach $aP (@preds) {

   $sS = $sS.$aP." ";

  }

  chomp ($sS);

  print FH "$aMotif - $sS\n";

 }

 if ($nM % 1000 == 0) {

  print "$nM motifs processed.\n";

 }

 $nM++;

}

close (FH);
close (FH2);

# profile

open (FH, ">$ARGV[2]");

foreach $goId (keys % profiles) {

 # background
 # in to out ratio

 $ior = log ($noProteins - $goCounts {$goId}) - log ($goCounts {$goId});

 print FH "$id2go{$goId} $ior $profiles{$goId}\n";

}

close (FH);

# hypergeometry implementations, courtesy of some guy on the net

sub logfact {

   return gammln (shift (@_) + 1.0);

}

sub hypergeom {

   # There are m "bad" and n "good" balls in an urn.
   # Pick N of them. The probability of i or more successful selections:
   # (m!n!N!(m+n-N)!)/(i!(n-i)!(m+i-N)!(N-i)!(m+n)!)

   # total positives - go term count
   # total negatives - total proteins - go term count
   # number sampled - motif count
   # at least this number positives among sample - motif count with go term

   # thus what is returned is probability under null hypothesis

   my ($n, $m, $N, $i) = @_;

   my $loghyp1 = logfact ($m) + logfact ($n) + logfact ($N) + logfact ($m + $n - $N);

   my $loghyp2 = logfact ($i) + logfact ($n - $i) + logfact ($m + $i - $N) + logfact ($N - $i) + logfact ($m + $n);

   return exp ($loghyp1 - $loghyp2);

}

sub gammln {

  my $xx = shift;

  my @cof = (76.18009172947146, -86.50532032941677,
             24.01409824083091, -1.231739572450155,
             0.12086509738661e-2, -0.5395239384953e-5);

  my $y = my $x = $xx;

  my $tmp = $x + 5.5;

  $tmp -= ($x + .5) * log ($tmp);

  my $ser = 1.000000000190015;

  for my $j (0..5) {

     $ser += $cof[$j]/++$y;

  }

  -$tmp + log (2.5066282746310005 * $ser / $x);

}