# !/usr/bin/perl
# note this script is huge, bulky, ugly and originally intended to do other things
# but now adapted to this purpose
# it assumes UNIX-like system and that gzip is installed
# input is a gzipped version of the swisspfam file from the Pfam installation
# and output is a file of the architectures in there as <uniprot ac> <uniprot id> <domain1*domain2*...>

$swissPfamFile = $ARGV [0]; # note: zipped

# cutoff

$useCutoff = 1;
$cutoff = 50;

# cutoff done

# repeat motif domain list done

open (FH, ">$ARGV[1]");

open (SPF, "gzip -dc $swissPfamFile |");

%currentEntry = ();  # the entry we are currently reading
$currentName = ""; # its name
$ac = "dummy";

$inEntry = - 1; # whether we are actually reading an entry or not
# before we have found any entries, this is - 1

$entryLength = 0; # the length in amino acids of this entry

while (<SPF>) {

 $aLine = $_;
 chomp ($aLine);

 if ($inEntry == - 1) {

  # in case this is an entry start, we will begin to store the entry
  # otherwise we just skip it

  if ($aLine =~ m/>(\w+)[\s\|]/) {  # start of first entry yay!

   # begin storing, store name, move to reading mode 1

   %currentEntry = ();
   $currentName = $1;

   $inEntry = 1;

   $aLine =~ m/\s(\S*)\s(\d*)\sa.a./;

   $ac = $1;
   $entryLength = $2; 
   $ac =~ /(\w*)\./;
   $b = $1;
   $ac = $b;

  }

 }

 elsif ($inEntry == 0) {

  # we are now between entries
  # we expect to find either end of file
  # or the start of a new entry

  if ($aLine =~ m/>(\w+)[\s\|]/) { # start of new entry yay!

   # begin storing, store name, move to reading mode 1

   %currentEntry = ();
   $currentName = $1;

   $inEntry = 1;

   $aLine =~ m/\s(\S*)\s(\d*)\sa.a./;

   $ac = $1;
   $entryLength = $2; 
   $ac =~ /(\w*)\./;
   $b = $1;
   $ac = $b;

  }

 }

 else {  # $inEntry is 1

  # we are in an entry
  # we expect either a(nother) domain row
  # or an empty row, in which case the entry should be processed

  if ($aLine =~ m/(PF\d{5}).+/) { # store yet another domain row

   # remain in reading mode 1, store this row

   $domain = $1;

   $bLine = $aLine." ";

   while ($bLine =~ /\s(\d+-\d+)/g) {

    $currentEntry {$1} = $domain;
  
   }

  }

  elsif (length ($aLine) == 0) {    # entry is done, process what we have read

   # process, then go to reading mode 0

   # now, currentEntry contains the domains

   @sorted = sort { seqCmp ($a, $b) } keys %currentEntry;

   $domainString = "";

   foreach $span (@sorted) {

    $domainString = $domainString.$currentEntry {$span}."*";

   }

   chop ($domainString);

   # check

   $noDomains = @sorted;

   # now, it is time for some checking!
   # we will make sure there is no overlap

   $overlap = 0;
   
   for ($i = 1; $i < $noDomains; $i++) {

    # there were at least two
    # check that this one begins
    # after the preceding ones end

    $iSpan = $sorted [$i];
    $iSpan =~ /^(\d*)-(\d*)$/;
    $iBegin = $1;
    $iEnd = $2;

    for ($j = 0; $j < $i; $j++) {

     # check that $j ends before $i begins

     $jSpan = $sorted [$j];
     $jSpan =~ /^(\d*)-(\d*)$/;
     $jBegin = $1;
     $jEnd = $2;

     if ($jEnd >= $iBegin) {

      # overlap!
      $overlap = 1;

     }

    }

   }

   # overlap checked

   $currentName =~ /([^_]*)_([^_]*)/;

   $speciesTag = $2;

   $speciesOK = 1;

   # we will check max unassigned

   $maxUnassigned = 0;

   # check between start and first

   $firstSpan = $sorted [0];
   $firstSpan =~ /^(\d*)-(\d*)$/;
   $firstBegin = $1;
   $firstEnd = $2;

   if ($firstBegin - 1 > $maxUnassigned) {

    $maxUnassigned = $firstBegin - 1;

   }

   # check between each

   for ($i = 1; $i < $noDomains; $i++) {

    $iSpan = $sorted [$i];
    $iSpan =~ /^(\d*)-(\d*)$/;
    $iBegin = $1;
    $iEnd = $2;     

    $jSpan = $sorted [$i - 1];
    $jSpan =~ /^(\d*)-(\d*)$/;
    $jBegin = $1;
    $jEnd = $2;     

    if ($iBegin - $jEnd > $maxUnassigned) {

     $maxUnassigned = $iBegin - $jEnd;

    }

   }

   # check after last

   $lastSpan = $sorted [$noDomains - 1];
   $lastSpan =~ /^(\d*)-(\d*)$/;
   $lastBegin = $1;
   $lastEnd = $2;     
   
   if ($entryLength - $lastEnd > $maxUnassigned) {

    $maxUnassigned = $entryLength - $lastEnd;

   }

   # do something about the cutoff

   $cutoffOK = 1;

   if ($useCutoff == 1 && $maxUnassigned > $cutoff) {

    $cutoffOK = 0;

   }

   # max unassigned checked

   # check done

   print FH "$ac $currentName $domainString\n";

   $inEntry = 0;   

  }

 }

}

close (SPF);

if ($inEntry == 1) {

 # now, currentEntry contains the domains

 @sorted = sort { seqCmp ($a, $b) } keys %currentEntry;

 $domainString = "";

 foreach $span (@sorted) {

  $domainString = $domainString.$currentEntry {$span}."*";

 }

 chop ($domainString);

   # check

   $noDomains = @sorted;

   # now, it is time for some checking!
   # we will make sure there is no overlap

   $overlap = 0;
   
   for ($i = 1; $i < $noDomains; $i++) {

    # there were at least two
    # check that this one begins
    # after the preceding ones end

    $iSpan = $sorted [$i];
    $iSpan =~ /^(\d*)-(\d*)$/;
    $iBegin = $1;
    $iEnd = $2;

    for ($j = 0; $j < $i; $j++) {

     # check that $j ends before $i begins

     $jSpan = $sorted [$j];
     $jSpan =~ /^(\d*)-(\d*)$/;
     $jBegin = $1;
     $jEnd = $2;

     if ($jEnd >= $iBegin) {

      # overlap!
      $overlap = 1;

     }

    }

   }

   # overlap checked

   $currentName =~ /([^_]*)_([^_]*)/;

   $speciesTag = $2;

   $speciesOK = 1;

   # we will check max unassigned

   $maxUnassigned = 0;

   # check between start and first

   $firstSpan = $sorted [0];
   $firstSpan =~ /^(\d*)-(\d*)$/;
   $firstBegin = $1;
   $firstEnd = $2;

   if ($firstBegin - 1 > $maxUnassigned) {

    $maxUnassigned = $firstBegin - 1;

   }

   # check between each

   for ($i = 1; $i < $noDomains; $i++) {

    $iSpan = $sorted [$i];
    $iSpan =~ /^(\d*)-(\d*)$/;
    $iBegin = $1;
    $iEnd = $2;     

    $jSpan = $sorted [$i - 1];
    $jSpan =~ /^(\d*)-(\d*)$/;
    $jBegin = $1;
    $jEnd = $2;     

    if ($iBegin - $jEnd > $maxUnassigned) {

     $maxUnassigned = $iBegin - $jEnd;

    }

   }

   # check after last

   $lastSpan = $sorted [$noDomains - 1];
   $lastSpan =~ /^(\d*)-(\d*)$/;
   $lastBegin = $1;
   $lastEnd = $2;     
   
   if ($entryLength - $lastEnd > $maxUnassigned) {

    $maxUnassigned = $entryLength - $lastEnd;

   }

   # do something about the cutoff

   $cutoffOK = 1;

   if ($useCutoff == 1 && $maxUnassigned > $cutoff) {

    $cutoffOK = 0;

   }

   # max unassigned checked

   # check done

   print FH "$ac $currentName $domainString\n";

}

close (FH);

sub seqCmp {

 $a =~ m/(\w+)-(\w+)/; 
 $aStart = $1; 
 $b =~ m/(\w+)-(\w+)/; 
 $bStart = $1;

 return $aStart <=> $bStart;

}
