#!/usr/bin/perl

# this thing reads... architectures, then id-gos data, then prints these into id form
# that is, replace architectures with motifs

# 0 - input architecture file
# 1 - input unid-gos file
# 2 - output motifs-gos file
# 3 - output motifs ids file


# domain architectures

%arch = ();

$noMotifs = 0;
%motif2id = ();
%id2motif = ();

open (FH, $ARGV [0]);

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 # this is the architecture file...

 @words = split (" ", $aLine);
 $id = $words [0];
 $anArch = $words [2];
 $arch {$id} = $anArch;

}

close (FH);

# main dataset

$nR = 0;

open (FH, $ARGV [1]);
open (FH2, ">$ARGV[2]"); # print out interpreted dataset

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 # this file is the main dataset, of type <id> <gos>

 @words = split (" ", $aLine);

 $N = @words;
 $id = $words [0];

 $anArch = $arch {$id};

 $sS = "";
 
 for ($i = 1; $i < $N; $i++) {

  # maybe better to involve ids here?


  $sS = $sS.$words [$i]." ";

 }

 chop ($sS);

 # now, we wish to find all the motifs this arch
 # contains and print them along with the gos ($sS)
 # whenever a new motif is discovered, we shall add it

 # first make it a set

 @aDs = split (/\*/, $anArch);
 %lDs = ();

 foreach $aD (@aDs) {

  if (! exists ($lDs {$aD})) {

   $lDs {$aD} = "";

  }

 }

 # then order it

 @sDs = sort { lc ($a) cmp lc ($b) } keys % lDs;
 $Nd = @sDs;

 # motifs in this example:

 $mS = "";

 # then take all the permutations

 for ($i = 1; $i < exp (log (2) * $Nd); $i++) {

  @posS = split (//, dec2bin ($i, $Nd));

  $tS = "";

  for ($j = 0; $j < $Nd; $j++) {

   if ($posS [$j] == 1) {

    $tS = $tS.$sDs [$j]."*";

   }

  }

  chop ($tS);
 
  # tS is a motif!

  if (! exists ($motif2id {$tS})) {

   $motif2id {$tS} = $noMotifs;
   $id2motif {$noMotifs} = $tS;
   $noMotifs++;

  }

  # add motif here

  $mS = $mS.$motif2id {$tS}." ";

 }

 chomp ($mS);

 # $mS are all the motifs in this example, $sS all the go terms

 print FH2 $mS." - ".$sS."\n";

 # done

 $nR++;

 if ($nR % 10000 == 0) {

  print "$nR done.\n"

 }

}

close (FH);
close (FH2);

# print out all the motifs

open (FH, ">$ARGV[3]");

for ($i = 0; $i < $noMotifs; $i++) {

 print FH "$i $id2motif{$i}\n";
 
}

close (FH);

# so, all motifs have been printed to file
# and the dataset have likewise been translated to file
# then the dataset can be split, and training applied to it

sub dec2bin {

    my $str = unpack("B32", pack("N", shift));
    my $nos = shift;
    $str = substr ($str, 32 - $nos, $nos);
    return $str;

}